VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frm_Masterdata 
   Caption         =   " Stammdaten Anzeige"
   ClientHeight    =   3945
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8715
   OleObjectBlob   =   "frm_Masterdata.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frm_Masterdata"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
    Option Explicit
    
   'API Funktion fr den Dialog fr die Dateiauswahl
    Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" ( _
        pOpenfilename As OPENFILENAME) As Long
    
   'API Funktion fr die Ermittlung des Fenster Handels
    Private Declare Function GetActiveWindow Lib "user32" () As Long

   'Konstanten fr den Dialog der Dateiauswahl (GetOpenFileName)
    Private Const OFN_FILEMUSTEXIST As Long = &H1000&
    Private Const OFN_HIDEREADONLY  As Long = &H4&
    Private Const OFN_PATHMUSTEXIST As Long = &H800&

   'Struktur fr den Dialog der Dateiauswahl (GetOpenFileName)
    Private Type OPENFILENAME
        lStructSize         As Long
        hwndOwner           As Long
        hInstance           As Long
        lpstrFilter         As String
        lpstrCustomFilter   As String
        nMaxCustFilter      As Long
        nFilterIndex        As Long
        lpstrFile           As String
        nMaxFile            As Long
        lpstrFileTitle      As String
        nMaxFileTitle       As Long
        lpstrInitialDir     As String
        lpstrTitle          As String
        flags               As Long
        nFileOffset         As Integer
        nFileExtension      As Integer
        lpstrDefExt         As String
        lCustData           As Long
        lpfnHook            As Long
        lpTemplateName      As String
    End Type
    
Private Sub cmdConfig_Click()
   
   'In dieser Sub werden die unvollstndigen Stammdaten eingerichtet. Hierbei geht es insbesondere
   'um das Standardverzeichnis, die Access Datenbank, Textfile mit XML Code und die Outlook Ansicht.
   
   'Fehlerroutine initialisieren
    On Error GoTo Err_MasterData

   'Falls das Standardverzeichnis noch nicht erstellt wird, Sub fr die Erstellung aufrufen.
    If gb_MasterData(0) Then Call Create_DefaultPath
    
   'Falls die Access Datenbank noch nicht im Standardverzeichnis ist, Sub aufrufen, damit der User
   'die Datei selektieren und kopieren kann.
    If gb_MasterData(1) And gl_Cancel <> Abort.Interrupted Then
        
       'Info fr User anzeigen, dass der Access Datenbank auswhlen muss.
        MsgBox "Bitte im nchsten Dialog die Access Datenbankdatei '" & gs_DBASE & "' auswhlen!" & _
               vbCr & vbCr & "Die Datei wird automatisch in das Standardverzeichnis kopiert.", _
               vbInformation, "Dateiauswahl"
               
       'Sub fr die Anzeige des Datei Dialoges und kopieren der Datei aufrufen.
        Call SelectAndCopyFile(gs_DBASE)
        
    End If

   'Falls die Textdatei mit XML Code noch nicht im Standardverzeichnis ist, Sub aufrufen, damit der User
   'die Datei selektieren und kopieren kann.
    If gb_MasterData(2) And gl_Cancel <> Abort.Interrupted Then
                
       'Info fr User anzeigen, dass er die Textdatei auswhlen muss.
        MsgBox "Bitte im nchsten Dialog die Textdatei mit XML Code '" & gs_XML & "' auswhlen!" & _
               vbCr & vbCr & "Die Datei wird automatisch in das Standardverzeichnis kopiert.", _
               vbInformation, "Dateiauswahl"
               
       'Sub fr die Anzeige des Datei Dialoges und kopieren der Datei aufrufen.
        Call SelectAndCopyFile(gs_XML)
        
    End If

   'Falls die Outlook Ansicht noch nicht erstellt wurde, Sub fr die Erstellung aufrufen.
    If gb_MasterData(3) And gl_Cancel <> Abort.Interrupted Then
        Call Create_OutlookView
    End If

   'Listbox mit Fehlerjournal leeren
    listJournal.Clear
    
   'Sub fr die Aktualisierung des Fehlerprotokolls aufrufen.
    Call Check_MasterData(True)
    
   'Prfen ob Fehler in den Stammdaten generiert wurden.
    If listJournal.ListCount > 0 Then
        MsgBox "Die Stammdaten wurden nicht vollstndig eingerichtet!", vbExclamation, "Fehler"
    Else
        MsgBox "Die Stammdaten wurden vollstndig eingerichtet!" & vbCr & vbCr & "Starten Sie " & _
               "die E-Mail Archivierung erneut.", vbInformation, "Stammdaten eingerichtet!"
        Unload Me
    End If
    
   'Zurcksetzen des Flags fr den Prozess-Abbruch.
    gl_Cancel = Abort.UserEditing
    
    Exit Sub

Err_MasterData:
    
   'Anzeige des Laufzeitfehlers
    Error_Msg Err, "Beim einrichten der Stammdaten ist ein unbekannter Fehler aufgetreten!"
    Unload Me

End Sub

Private Sub Create_DefaultPath()

   'In dieser Prozedur wird das Standardverzeichnis gemss der globalen Variable erstellt.

    Dim i            As Long
    Dim strPath      As String
    Dim strFolders() As String
        
    i = 1
    
   'Standardverzeichnis in einzelne Verzeichnisse splitten
    strFolders = Split(Left(gs_PATH, Len(gs_PATH) - 1), "\", -1, vbBinaryCompare)
    
   'Den Laufwerksbuchstaben in die Variable schreiben mit einem Backslash am Ende.
    strPath = strFolders(0) & "\"
    
   'Prfen ob das Laufwerk existiert.
    If Dir(strPath, vbNormal) <> "" Then
    
       'Falls das Laufwerk existiert, wird nun der Reihe nach jedes einzelne Unterverzeichnis
       'auf Existenz geprft. Falls es noch nicht erstellt wurde, wird dies nun gemacht.
        Do Until UBound(strFolders) < i
           
           'Dem bereits bestehenden Pfad das nchste Unterverzeichnis anhngen.
            strPath = strPath & strFolders(i) & "\"
            
           'Prfen ob das Unterverzeichnis besteht, falls nicht, wird es erstellt.
            If Dir(strPath, vbDirectory) = "" Then MkDir strPath
            
           'Index um eins erhhen.
            i = i + 1
            
        Loop
        
    Else
       
       'Falls der Laufwerksbuchstabe nicht korrekt ist, wird das Flag auf Prozess-Abbruch gesetzt.
        gl_Cancel = Abort.Interrupted
        
    End If
    
   'Nochmalige Prfung ob, das Verzeichnis erstellt wurde, sonst Flag auf Prozess-Abbruch setzen.
    If Dir(gs_PATH, vbDirectory) = "" Then gl_Cancel = Abort.Interrupted
    
End Sub

Private Sub SelectAndCopyFile(ByVal vsFileName As String)

   'In dieser Prozedur wird ein Dialog fr die Dateiauswahl aufgerufen. Sofern der User eine Datei
   'ausgewhlt hat, wird diese (entweder Access Datenbank oder Textdatei mit XML Code) in das
   'Standardverzeichnis der E-Mail Archivierung kopiert.

    Dim lReturn     As Long
    Dim OpenFile    As OPENFILENAME
    
   'Einstellungen fr die Anzeige des Datei Dialoges.
    OpenFile.lStructSize = Len(OpenFile)
    OpenFile.hwndOwner = GetActiveWindow
    OpenFile.lpstrFilter = vsFileName & " (*.mdb)" & Chr(0) & vsFileName & Chr(0)
    OpenFile.nFilterIndex = 1
    OpenFile.lpstrFile = String(257, 0)
    OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
    OpenFile.lpstrFileTitle = OpenFile.lpstrFile
    OpenFile.nMaxFileTitle = OpenFile.nMaxFile
    OpenFile.lpstrTitle = "Bitte Datei '" & vsFileName & "' selektieren!"
    OpenFile.flags = OFN_FILEMUSTEXIST Or OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY
    
   'Anzeige des Datei Dialoges. Der Rckgabewert zeigt, ob der User den Dialog abgebrochen hat oder
   'ob er eine Datei ausgewhlt hat.
    lReturn = GetOpenFileName(OpenFile)
    
   'Prfen ob eine Datei ausgewhlt wurde.
    If lReturn = 0 Then
       'Falls keine Datei ausgewhlt wurde, Flag auf Prozess-Abbruch setzen.
        gl_Cancel = Abort.Interrupted
    Else
       'Falls eine Datei ausgewhlt wurde, wird diese in das Standardverzeichnis kopiert.
        FileCopy Trim(OpenFile.lpstrFile), gs_PATH & vsFileName
    End If

End Sub

Private Sub Create_OutlookView()

   'In dieser Prozedur wird die Textdatei mit dem XML Code fr die Outlook Ansicht ausgelesen und
   'in eine Variable geschrieben. Danach wird eine neue Outlook Ansicht fr die Archivierungs-
   'Verzeichnisse erstellt und mit dem XML Code in das gewnschte Format gendert.

    Dim lngFNo      As Long
    Dim strXML      As String
    Dim objView     As View
    Dim objViews    As Views

   'Freite Dateinummer in Variable schreiben.
    lngFNo = FreeFile
    
   'Textdatei mit dem XML Code fr die Outlook Ansicht ffnen und XML Code in Variable schreiben.
    Open gs_PATH & gs_XML For Binary Access Read As lngFNo
        strXML = String(LOF(lngFNo), 0)
        Get lngFNo, 1, strXML
    Close lngFNo
    
   'Views Collection in Objektvariable schreiben.
    Set objViews = Application.Session.GetDefaultFolder(olFolderInbox).Views
    
   'Neue Outlook Ansicht erstellen
    Set objView = objViews.Add(gs_VIEW, olTableView, olViewSaveOptionAllFoldersOfType)

   'XML Code der neu erstellten Outlook Ansicht ndern und nsicht speichern.
    objView.XML = strXML
    objView.Save

End Sub

Private Sub UserForm_Initialize()
    
   'Als Information fr den User werden die Stammdaten gemss den globalen Variablen beim laden der
   'User Form in Textboxen geschrieben.
    
   'Zurcksetzen des Flags fr den Prozess-Abbruch.
    gl_Cancel = Abort.UserEditing
    
   'Auslesen der globalen Variablen und Textboxen abfllen.
    txtPath.Text = gs_PATH
    txtDB.Text = gs_DBASE
    txtView.Text = gs_VIEW
    txtXML.Text = gs_XML
            
End Sub

Private Sub cmdCancel_Click()

    Unload Me
   
End Sub
