Attribute VB_Name = "mod_Initialize"
    Option Explicit

   'Definition der globalen Konstanten
    Public Const gs_PATH        As String = "C:\Outlook\Archiv\" 'Standard Pfad (mit Backslash am Ende!)
    Public Const gs_VIEW        As String = "Archive_View"       'Name des View-Objektes
    Public Const gs_DBASE       As String = "dbaEMails.mdb"      'Name der Access-Datenbank
    Public Const gs_DESCRIPTION As String = "ArchiveFolder"      'Standart Archiv Beschreibung
    Public Const gs_TAG_BUTTON  As String = "ArchiveMenuButton"  'Standart Tag Menbutton
    Public Const gs_TAG_POPUP   As String = "ArchiveMenuPopup"   'Standart Tag Menpopup
    Public Const gs_XML         As String = "OLKViewXML.txt"     'Name des Textfiles mit XML Code
    
   'Definition der globalen Variablen
    Public gl_Cancel            As Long                 'Flag fr den Prozess-Abbruch
    Public gb_AcceptAll         As Boolean              'Flag fr automatische Archivierung
    Public gb_IgnoreAll         As Boolean              'Flag fr Ignorierung unbekannter Adressen
    Public gb_MasterData()      As Boolean              'Flag fr Fehlermeldungen der Stammdaten
    Public gs_Multiple          As String               'Flag fr doppelte EMail Archivierung
    Public gsa_Folders()        As String               'Verzeichnisse pro EMail fr Archivierung
    Public ga_Mails()           As Mail_TYPE            'Array fr das Auslesen der EMails
    Public ga_Archives()        As Archive_TYPE         'Array fr das Auslesen der Archive
    Public gdb_Mails            As New ADODB.Recordset  'Datenbank-Tabelle der EMail-Adressen
    Public gdb_Folders          As New ADODB.Recordset  'Datenbank-Tabelle der Archiv-Verzeichnisse
    Public g_CmdButton          As CommandBarButton     'selbst erstellter Menbutton

   'Definition des benutzerdefinierten Datentyps fr das Auslesen der EMails.
    Public Type Mail_TYPE
        sEntryID                As String   'EntryID
        sStoreID                As String   'StoreID
        saName()                As String   'Name
        saAddress()             As String   'Adresse
        bSentMySelf             As Boolean  'Gesendet oder Erhalten
    End Type
    
   'Definition des benutzerdefinierten Datentyps fr das Auslesen der Archive.
    Public Type Archive_TYPE
        sFolderName             As String   'Verzeichnis-Name
        sEntryID                As String   'EntryID
        sStoreID                As String   'StoreID
        dtFrom                  As Date     'Archivierungs-Zeitraum 'von'
        dtTo                    As Date     'Archivierungs-Zeitraum 'bis'
    End Type
    
   'Definition benutzerdef. Datentyp fr das Auslesen von Fehlern beim Verknpfen von *.pst Dateien
    Private Type ErrStore_TYPE
        lErrNo      As Long
        sPath       As String
        sErrDesc    As String
        sErrSource  As String
    End Type
    
   'Definition der Konstanten fr das Flag 'gl_Cancel' (Prozess-Abbruch).
    Public Enum Abort
        InProgress = 0
        UserEditing = 1
        Interrupted = 2
    End Enum

Private Sub Initialize_MailArchiving()

   'Diese Prozedur wird ausgefhrt, sobald der User auf den selbst erstellten CommandBarButton klickt.
   'Damit wird die EMail-Archivierung initialisiert und der User muss ein Outlook Verzeichnis aus dem
   'PickFolder Dialog auswhlen, in dem sich die EMail-Objekte befinden, die archiviert werden sollen.

    Dim objPickFolder As MAPIFolder

   'Laufzeitfehler (auch in Subprozeduren) die nicht innerhalb einer lokalen Fehlerroutine entstanden
   'sind, werden in dieser Fehlerroutine abgefangen. Dies bezieht sich nur auf Prozeduren fr das Aus-
   'lesen der Archiv-Verzeichnisse und der EMails.
    On Error GoTo Err_Unknown

   'Stammdaten berprfen (Standardpfad, Datenbank, Textdatei und View-Objekt).
    If Check_MasterData Then

       'Der User muss mit Hilfe des PickFolder Dialoges ein Outlook Verzeichnis auswhlen.
        Set objPickFolder = Application.Session.PickFolder
    
       'Prfen ob der User ein Verzeichnis im PickFolder Dialog ausgewhlt hat.
        If Not objPickFolder Is Nothing Then
            
           'Globale benutzerdefinierte Arrays fr das Auslesen der EMails und der Archiv-Verzeichnisse
           'initialisieren. Die Position 0 ist eine Dummy-Position und wird nie mit Daten bestckt.
            ReDim ga_Mails(0) As Mail_TYPE
            ReDim ga_Archives(0) As Archive_TYPE
            
           'Den selbst erstellten CommandBarButton in eine globale Objekt-Variable schreiben.
            Set g_CmdButton = ActiveExplorer.CommandBars.FindControl(msoControlButton, , gs_TAG_BUTTON)
            
           'Menposition sperren, damit die Archivierung kein 2. Mal aufgerufen werden kann.
            g_CmdButton.Enabled = False
        
           'Flag fr den Prozess-Abbruch zurcksetzen.
            gl_Cancel = Abort.InProgress
        
           'UserForm ungebunden anzeigen.
            frm_ReadObjects.Show False
           
           'Prozedur fr das Auslesen der einzelnen Objekte starten.
            Call Initialize_ReadOutProcess(objPickFolder)
            
        End If
        
    End If
    
   'Prozedur beenden.
    Exit Sub
    
Err_Unknown:

   'Ausgelster Laufzeitfehler mit Messagebox anzeigen.
    Call Error_Msg(Err, "Ein unbekannter Fehler ist aufgetreten!")

End Sub

Public Function Check_MasterData(Optional ByVal bRecheck As Boolean = False) As Boolean

   'Prfung ob Standart-Pfad vorhanden ist und die Datenbank im Standart-Pfad mit richtigem Namen abge-
   'legt ist. Ebenfalls wird geprft, ob das Standart-View Objekt erstellt wurde. Falls die Prfung ein
   'Fehler ergibt, wird eine UserForm angezeigt, mit der sich die Stammdaten einrichten lassen.

   'Flag fr Fehlermeldungen initialisieren
    ReDim gb_MasterData(3) As Boolean
    
   'Prfen ob die Funktion nochmalig aufgerufen wurde.
    If Not bRecheck Then Load frm_Masterdata

    With frm_Masterdata.listJournal

       'Prfen ob Standartverzeichnis vorhanden ist.
        If Dir(gs_PATH, vbDirectory) = "" Then
            'Eintrag im Fehlerprotokol der Stammdaten UserForm vornehmen.
            .AddItem "Error >> Das Standardverzeichnis '" & gs_PATH & "' wurde nicht gefunden!"
            gb_MasterData(0) = True 'Flag auf True setzen
        End If
         
       'Prfen ob Access Datenbankfile vorhanden ist.
        If Dir(gs_PATH & gs_DBASE, vbNormal) = "" Then
            'Eintrag im Fehlerprotokol der Stammdaten UserForm vornehmen.
            .AddItem "Error >> Die Access Datenbank '" & gs_DBASE & "' ist im Verzeichnis '" & _
                      gs_PATH & "' nicht vorhanden!"
            gb_MasterData(1) = True 'Flag auf True setzen
        End If
         
       'Prfen ob die XML Code Datei fr das View-Objekt vorhanden ist.
        If Dir(gs_PATH & gs_XML, vbNormal) = "" Then
            'Eintrag im Fehlerprotokol der Stammdaten UserForm vornehmen.
            .AddItem "Error >> Die Datei '" & gs_XML & "' ist im Verzeichnis '" & gs_PATH & "' nicht vorhanden!"
            gb_MasterData(2) = True 'Flag auf True setzen
        End If
         
       'Prfen ob das View-Objekt erstellt wurde.
        If Application.Session.GetDefaultFolder(olFolderInbox).Views(gs_VIEW) Is Nothing Then
            'Eintrag im Fehlerprotokol der Stammdaten UserForm vornehmen.
            .AddItem "Error >> Die Outlook Ansicht '" & gs_VIEW & "' wurde in Outlook noch nicht " & _
                     "erstellt!"
            gb_MasterData(3) = True 'Flag auf True setzen
        End If
    
    End With

   'Falls die Funktion nochmalig aufgerufen wurde, Funktion beenden.
    If bRecheck Then Exit Function

   'Prfen ob Fehler in den Stammdaten gefunden wurde.
    If frm_Masterdata.listJournal.ListCount > 0 Then
       'Bei gefundenen Fehlern, UserForm mit Fehlerprotokoll anzeigen
        frm_Masterdata.Show
    Else
       'Falls keine Fehler gefunden wurden, UserForm Stammdaten schliessen und Flag auf True setzen.
        Check_MasterData = True
        Unload frm_Masterdata
    End If
    
End Function

Private Sub Reconnect_DataFiles()

   'In dieser Prozedur werden in Outlook smtliche *.pst Dateien, die sich im Standardverzeichnis
   'befinden, wieder Verknpft. Diese Prozedur kann ber das selbst erstellte Popupmen aufge-
   'rufen werden. Falls eine oder mehrere Verknpfungen bereits bestehen, wird dies kein Lauf-
   'zeitfehler verursachen.

    Dim i           As Long
    Dim strFile     As String
    Dim strErrMsg   As String
    Dim ErrStore()  As ErrStore_TYPE
    
   'Fehlerroutine initialisieren.
    On Error GoTo Err_ReconnectDataFile
    
   'Variable fr die Speicherung der Fehlermeldungen initialisieren.
    ReDim ErrStore(0) As ErrStore_TYPE
    
   'Standardverzeichnis nach *.pst Dateien durchsuchen
    strFile = Dir(gs_PATH & "*.pst", vbNormal)
    
   'Prfen ob mindestens eine *.pst Datei gefunden wurde
    If strFile <> "" Then
    
       'Falls *.pst Dateien vorhanden sind, werden in der nachfolgenden Schleife alle ausgelesen.
        Do While strFile <> ""
            
           'Verknpfung in Outlook mit Data File wieder herstellen.
            Application.Session.AddStoreEx (gs_PATH & strFile), olStoreDefault
    
NextDataFile:

           'Nach nchster *.pst Datei im Standardverzeichnis suchen.
            strFile = Dir
    
        Loop
        
    Else
    
       'Falls keine *.pst Dateien vorhanden sind, Message anzeigen und Prozedur beenden.
        MsgBox "Im Standardverzeichnis '" & gs_PATH & "' wurden keine *.pst Dateien gefunden!", _
                vbExclamation, "Nichts gefunden!"
        
        Exit Sub
    
    End If

   'Prfen ob ein Laufzeitfehler ausgelst wurde.
    If ErrStore(0).sPath <> "" Then

       'Falls ja, alle Laufzeitfehler auslesen und Fehlerbericht erstellen.
        For i = 0 To UBound(ErrStore) - 1
            With ErrStore(i)
                strErrMsg = strErrMsg & "  Pfad:" & vbTab & .sPath & vbCr & _
                            "  F-Nr:" & vbTab & .lErrNo & vbCr & _
                            "  Quelle:" & vbTab & .sErrSource & vbCr & _
                            "  Fehler:" & vbTab & .sErrDesc & vbCr & vbCr
            End With
        Next i
    
       'Fehlerbericht mittels Messagebox anzeigen.
        MsgBox "Nachfolgende *.pst Datei(en) konnte(n) nicht verknpft werden:" & vbCr & _
                vbCr & strErrMsg, vbCritical, "Verbindungsfehler!"
    
    Else
    
       'Message anzeigen, falls alle *.pst Dateien fehlerlos in Outlook verknpft wurden.
        MsgBox "Alle *.pst Dateien im Standardverzeichnis '" & gs_PATH & "' wurden mit " & _
               "Outlook verknpft.", vbInformation, "Verknpfungen erstellt!"
    
    End If

    Exit Sub
    
Err_ReconnectDataFile:

   'Falls ein Laufzeitfehler auftritt, werden smtliche Infos des Fehlers, sowie der Pfad in eine
   'Variable geschrieben.
   
    With ErrStore(UBound(ErrStore))
        .sPath = gs_PATH & strFile      'Pfad der *.pst Datei
        .lErrNo = Err.Number            'Nummer des Laufzeitfehlers
        .sErrSource = Err.Source        'Quelle des Laufzeitfehlers
        .sErrDesc = Err.Description     'Beschreibung des Laufzeitfehlers
    End With
    
   'Das Array fr die Speicherung der Laufzeitfehler um eine Position erweitern.
    ReDim Preserve ErrStore(UBound(ErrStore) + 1) As ErrStore_TYPE
    
   'Rckkehr in die DoLoop schleife um weitere *.pst Dateien auszulesen resp. zu verknpfen.
    Resume NextDataFile

End Sub

Private Sub View_MasterData()
    
   'Mit dieser Prozedur wird die UserForm der Stammdaten angezeigt. Da sich hier nur um eine Info
   'handelt, wird der Button fr das einrichten der Stammdaten deaktiviert, bevor die UserForm
   'angezeigt wird.

   'UserForm laden
    Load frm_Masterdata
    
   'Prfung der Stammdaten laufen lassen.
    Call Check_MasterData(True)
    
   'Button deaktivieren.
    frm_Masterdata.cmdConfig.Enabled = False
    
   'UserForm anzeigen.
    frm_Masterdata.Show

End Sub

Sub Add_CmdPopupArchive(ByRef rCmdPopup As CommandBarPopup)

   'In dieser Prozedur wird der CommandBarButton erstellt, mit dem die EMail-Archivierung gestartet
   'werden kann. Der Button wird in der Standart Menubar von Outlook im Popupmenu Extras an letzter
   'Position hinzugefgt.

   'Fehler-Routine fr die Erstellung des CommandBarButtons initialisieren.
    On Error GoTo Err_AddCmdPopup
    
   'Falls die Standart Menubar geschtzt ist, muss der Schutz deaktiviert werden.
    ActiveExplorer.CommandBars("Menu Bar").Protection = msoBarNoProtection
    
   'Falls der CommandBarButton bereits existiert, wird er gelscht.
    If Not rCmdPopup Is Nothing Then rCmdPopup.Delete
    
   'Mit Hilfe der ID nach dem Popupmenu Extras suchen.
    With ActiveExplorer.CommandBars.FindControl(msoControlPopup, 30007)
    
       'Das Popupmenu Extras einblenden (Vorsorge falls es ausgeblendet wurde).
        .Visible = True
        
       'Das CommandbarPopup Men im Popupmenu Extras temporr an letzter Position erstellen.
        With .Controls.Add(msoControlPopup, , , , True)
            .BeginGroup = True                          'Trennline vor Button einblenden
            .Caption = "&Archiving Tool"                'Bezeichnung des Buttons
            .Tag = gs_TAG_POPUP                         'Tag Eigenschaft fr die Identifikation
        
           'CommandBarButton im Popupmenu 'E-Mail Archiving' temporr an letzter Position erstellen.
            With .Controls.Add(msoControlButton, , , , True)
                .Caption = "&Archive Mails..."          'Bezeichnung des Buttons
                .FaceId = 1679                          'Icon des Buttons
                .OnAction = "Initialize_MailArchiving"  'Prozedur fr das Click Ereignis des Buttons
                .Style = msoButtonIconAndCaption        'Ansicht des Buttons
                .Tag = gs_TAG_BUTTON                    'Tag Eigenschaft fr die Identifikation
            End With
           
           'CommandBarButton im Popupmenu 'E-Mail Archiving' temporr an letzter Position erstellen.
            With .Controls.Add(msoControlButton, , , , True)
                .Caption = "&Reconnect Data Files"      'Bezeichnung des Buttons
                .FaceId = 7790                          'Icon des Buttons
                .OnAction = "Reconnect_DataFiles"          'Prozedur fr das Click Ereignis des Buttons
                .Style = msoButtonIconAndCaption        'Ansicht des Buttons
            End With
        
           'CommandBarButton im Popupmenu 'E-Mail Archiving' temporr an letzter Position erstellen.
            With .Controls.Add(msoControlButton, , , , True)
                .BeginGroup = True                      'Trennline vor Button einblenden
                .Caption = "&View Master Data..."       'Bezeichnung des Buttons
                .FaceId = 2502                          'Icon des Buttons
                .OnAction = "View_MasterData"           'Prozedur fr das Click Ereignis des Buttons
                .Style = msoButtonIconAndCaption        'Ansicht des Buttons
            End With
                
        End With
    End With
    
   'Prozedur beenden.
    Exit Sub

Err_AddCmdPopup:
     
   'Ausgelster Laufzeitfehler mit Messagebox anzeigen.
    Call Error_Msg(Err, "Popupmen 'Archive MailItems' konnte nicht erstellt werden!")
   
End Sub

Public Sub Cancel_Process(ByRef rForm As UserForm, Optional ByRef viCancel As Integer = 9)

   'Diese Prozedur wird bei jedem Versuch die UserForm zu schliessen aufgerufen. Dem Anwender wird eine
   'Messagebox angezeigt, mit der er sein Vorhaben besttigen muss oder rckgngig machen kann. Damit
   'der Abbruch allenfalls korrekt zurckgesetzt werden kann, muss unterschieden werden, ob der Abbruch
   'ber das Klick Ereignis des Abbrechen Buttons oder ber das QueryClose Ereignis ausgelst wurde.
   'Zudem muss unterschieden werden, ob ein Prozess im Gange ist oder nicht.

   'Abfrage fr Abbruch-Besttigung des Anwenders einblenden.
    If MsgBox("Wollen Sie den Archivierungs-Prozess wirklich vorzeitig beenden?", _
               vbOKCancel + vbExclamation + vbDefaultButton2, "Prozess Abbruch") = vbOK Then
    
       'Abbrechen Button auf der UserForm deaktivieren.
        rForm.cmdCancel.Enabled = False
        
       'Prfen ob Prozess im Gange ist.
        Select Case gl_Cancel
           
           'Kein Prozess im Gange.
            Case Abort.UserEditing
                
               'Falls Abbruch ber Button ausgelst wurde, Unload Anweisung ausfhren.
                If viCancel = 9 Then Unload rForm
            
           'Laufender Prozess im Gange.
            Case Abort.InProgress
                
               'Falls Abbruch ber QueryClose Ereignis ausgelst wurde, muss die Unload Anweisung zu-
               'rckgesetzt werden. Ansonsten hatt diese Code-Zeile keine Auswirkungen. Die Unload An-
               'weisung wird erst nach dem Beenden aller laufender Prozesse aufgerufen.
                viCancel = True
                
        End Select
        
       'Flag fr den Prozess Abbruch auf 'Prozess abgebrochen' setzen.
        gl_Cancel = Abort.Interrupted
        
       'Menubutton wieder aktivieren.
        g_CmdButton.Enabled = True
        
    Else
    
       'Falls Abbruch ber QueryClose Ereignis ausgelst wurde, muss die Unload Anweisung zurckgesetzt
       'werden. Ansonsten hat diese Code-Zeile keine Auswirkungen.
        viCancel = True
        
    End If
    
End Sub

Public Function Error_Msg(ByRef rError As ErrObject, ByVal vsMsgText As String) As VbMsgBoxResult
   
   'Diese Prozedur wird verwendet, um dem Anwender entstandene Laufzeitfehler anzuzeigen.
   
    Dim strTitle    As String
    Dim strSource   As String
    Dim strError    As String
    
   'Titel fr die Messagebox erstellen.
    strTitle = "Laufzeitfehler Nr. " & rError.Number
    
   'Text fr die Fehlerbeschreibung generieren.
    If rError.Number = 0 Then
        strSource = "n/A"
        strError = "n/A"
    Else
        strSource = rError.Source
        strError = rError.Description
    End If
    
   'Text fr die Messagebox mit Daten des Laufzeitfehlers ergnzen.
    vsMsgText = vsMsgText & String(2, vbCr) & _
               "Quelle:" & vbTab & strSource & vbCr & _
               "Fehler:" & vbTab & strError

   'Messagebox anzeigen und Rckgabewert der Funktion bergeben.
    Error_Msg = MsgBox(vsMsgText, vbCritical, strTitle)

End Function
